"use strict";

function _typeof(o) { "@babel/helpers - typeof"; return _typeof = "function" == typeof Symbol && "symbol" == typeof Symbol.iterator ? function (o) { return typeof o; } : function (o) { return o && "function" == typeof Symbol && o.constructor === Symbol && o !== Symbol.prototype ? "symbol" : typeof o; }, _typeof(o); }
Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.saveCacheData = exports.removeCacheItem = exports.getCacheData = exports["default"] = exports.TimeUnit = exports.LocalTimeUnit = void 0;
var _md = _interopRequireDefault(require("crypto-js/md5"));
var _axios = _interopRequireDefault(require("axios"));
var _cache2 = require("./cache");
var _excluded = ["baseURL", "timeout", "tokenKey", "cacheUrls", "statusCodeMapping", "responseInterceptor", "requestInterceptor", "getToken"];
function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }
function _objectDestructuringEmpty(obj) { if (obj == null) throw new TypeError("Cannot destructure " + obj); }
function _extends() { _extends = Object.assign ? Object.assign.bind() : function (target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i]; for (var key in source) { if (Object.prototype.hasOwnProperty.call(source, key)) { target[key] = source[key]; } } } return target; }; return _extends.apply(this, arguments); }
function ownKeys(e, r) { var t = Object.keys(e); if (Object.getOwnPropertySymbols) { var o = Object.getOwnPropertySymbols(e); r && (o = o.filter(function (r) { return Object.getOwnPropertyDescriptor(e, r).enumerable; })), t.push.apply(t, o); } return t; }
function _objectSpread(e) { for (var r = 1; r < arguments.length; r++) { var t = null != arguments[r] ? arguments[r] : {}; r % 2 ? ownKeys(Object(t), !0).forEach(function (r) { _defineProperty(e, r, t[r]); }) : Object.getOwnPropertyDescriptors ? Object.defineProperties(e, Object.getOwnPropertyDescriptors(t)) : ownKeys(Object(t)).forEach(function (r) { Object.defineProperty(e, r, Object.getOwnPropertyDescriptor(t, r)); }); } return e; }
function _defineProperty(obj, key, value) { key = _toPropertyKey(key); if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }
function _toPropertyKey(arg) { var key = _toPrimitive(arg, "string"); return _typeof(key) === "symbol" ? key : String(key); }
function _toPrimitive(input, hint) { if (_typeof(input) !== "object" || input === null) return input; var prim = input[Symbol.toPrimitive]; if (prim !== undefined) { var res = prim.call(input, hint || "default"); if (_typeof(res) !== "object") return res; throw new TypeError("@@toPrimitive must return a primitive value."); } return (hint === "string" ? String : Number)(input); }
function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }
function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }
var _cache = (0, _cache2.cache)(),
  saveData = exports.saveCacheData = _cache.saveData,
  saveStartTime = _cache.saveStartTime,
  getData = exports.getCacheData = _cache.getData,
  removeItem = exports.removeCacheItem = _cache.removeItem,
  TimeUnit = exports.TimeUnit = _cache.TimeUnit,
  LocalTimeUnit = exports.LocalTimeUnit = _cache.LocalTimeUnit;
var timeoutUrl = {};
var saveCacheByUrl = function saveCacheByUrl(value, data, urls) {
  var url = value.url || value;
  var config = urls[url] || {};
  if (config) {
    config.url = url;
    config.key = (0, _md["default"])(JSON.stringify(value)).toString();
    config.data = {
      data: data
    };
    saveData(config);
  }
};
var getCacheByUrl = function getCacheByUrl(value, urls) {
  var config = urls[value.url] || {};
  if (config) {
    var data = getData((0, _md["default"])(JSON.stringify(value)).toString());
    return data;
  }
};
var requestByCache = function requestByCache(_ref) {
  var config = _ref.config,
    request = _ref.request,
    urls = _ref.urls,
    _ref$args = _ref.args,
    args = _ref$args === void 0 ? {
      unDoCache: false
    } : _ref$args;
  if (args.unDoCache) {
    return request(config);
  }
  var md = (0, _md["default"])(JSON.stringify(config)).toString();
  if (timeoutUrl[md]) {
    if (!timeoutUrl[md].data) {
      return new Promise(function (resolve, reject) {
        reject({
          code: '1003',
          message: '正在加载数据，请等待！！'
        });
      });
    } else {
      delete timeoutUrl[md];
    }
  }
  timeoutUrl[md] = {};
  return (getCacheByUrl(config, urls) || request(config).then(function (response) {
    saveStartTime(response.headers['start-time']);
    saveCacheByUrl(config, response.data, urls);
    return response;
  })).then(function (response) {
    timeoutUrl[md].data = response.data;
    return response;
  }, function (error) {
    delete timeoutUrl[md];
    return error;
  })["catch"](function () {
    return delete timeoutUrl[md];
  });
};
var _default = exports["default"] = function _default(_ref2) {
  var baseURL = _ref2.baseURL,
    _ref2$timeout = _ref2.timeout,
    timeout = _ref2$timeout === void 0 ? 5000 : _ref2$timeout,
    _ref2$tokenKey = _ref2.tokenKey,
    tokenKey = _ref2$tokenKey === void 0 ? 'Authorization' : _ref2$tokenKey,
    cacheUrls = _ref2.cacheUrls,
    statusCodeMapping = _ref2.statusCodeMapping,
    _ref2$responseInterce = _ref2.responseInterceptor,
    responseInterceptor = _ref2$responseInterce === void 0 ? {} : _ref2$responseInterce,
    _ref2$requestIntercep = _ref2.requestInterceptor,
    requestInterceptor = _ref2$requestIntercep === void 0 ? function () {} : _ref2$requestIntercep,
    _ref2$getToken = _ref2.getToken,
    getToken = _ref2$getToken === void 0 ? function () {} : _ref2$getToken,
    config = _objectWithoutProperties(_ref2, _excluded);
  var request = _axios["default"].create(_objectSpread({
    baseURL: baseURL,
    timeout: timeout
  }, config));
  request.interceptors.request.use(function (_ref3) {
    var config = _extends({}, (_objectDestructuringEmpty(_ref3), _ref3));
    requestInterceptor(config);
    config.headers[tokenKey] = getToken();
    return config;
  }, function (error) {
    throw error;
  });
  if (responseInterceptor.response && responseInterceptor.error) {
    request.interceptors.response.use(responseInterceptor.response, responseInterceptor.error);
  } else {
    request.interceptors.response.use(function (response) {
      return response;
    }, function (error) {
      var rejectObject = {
        error: error,
        type: 'error',
        message: '未定义的错误。'
      };
      if (!error.response) {
        rejectObject.message = '网络异常，请稍后刷新重试！';
        rejectObject.code = '1001';
      } else if (error.response.status === 401 || error.response.status === 403) {
        rejectObject.message = '无权访问！';
        rejectObject.code = '1002';
        rejectObject.type = 'low.power';
      } else {
        if (error.response.status === 502) {
          rejectObject.message = '网络繁忙，请稍候重试！';
        } else if (error.response && error.response.data && error.response.data.message) {
          rejectObject.message = error.response.data.message;
        } else if (error.message) {
          rejectObject.message = error.message;
        }
      }
      if (statusCodeMapping && error.response && error.response.data && statusCodeMapping[error.response.data.status]) {
        statusCodeMapping["".concat(error.response.data.status)](error.response.data);
      }
      return Promise.reject(rejectObject);
    });
  }
  return {
    request: request,
    finds: function finds(config) {
      var args = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : {};
      if (cacheUrls) {
        return requestByCache({
          config: _objectSpread(_objectSpread({}, config), {}, {
            method: 'get'
          }),
          request: request,
          urls: cacheUrls,
          args: args
        });
      } else {
        return request(config);
      }
    },
    post: function post(config) {
      return request(_objectSpread(_objectSpread({}, config), {}, {
        method: 'post'
      }));
    },
    put: function put(config) {
      return request(_objectSpread(_objectSpread({}, config), {}, {
        method: 'put'
      }));
    },
    del: function del(config) {
      return request(_objectSpread(_objectSpread({}, config), {}, {
        method: 'delete'
      }));
    },
    get: function get(config) {
      return request(_objectSpread(_objectSpread({}, config), {}, {
        method: 'get'
      }));
    }
  };
};